

/***************************************************************************
 *   Copyright (C) 2007 by Stefan Lau   *
 *   stefan.lau@gmx.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DEF_H
#define DEF_H

#ifdef __WIN32__
	#define Win 1
#else
	#define Win 0
#endif


#include <QTreeWidgetItem>
#include <vector>

class OFileConnection
{
	public:
		OFileConnection();
		OFileConnection(const OFileConnection& FC);
		OFileConnection(QString LocalFile, QString ServerFile);
		
		QString ServerFile;
		QString LocalFile;

		bool ExistsLocal;
		bool ExistsServer;
		QString LastModifiedLocal;
		QString LastModifiedServer;
		int SizeLocal;
		int SizeServer;
		
		QString ServerFileMDTM;
		QString LocalFileMDTM;

		bool New;

		QTreeWidgetItem *ServerWidgetItem;
		QTreeWidgetItem *LocalWidgetItem;
};

class OProfile
{
	public:
		OProfile();
		OProfile(const OProfile&);

		QString Name;

		QString Server;
		QString Username;
		QString Password;
		QString ServerBaseDir;
		QString LocalBaseDir;
		bool CheckForMDTM;
		bool CheckForSize;
		std::vector<OFileConnection*> Files;

		int TimeDifference;

		std::vector<OFileConnection*> LookForServerFile(QString ServerFile);
		std::vector<OFileConnection*> LookForLocalFile(QString LocalFile);
		std::vector<OFileConnection*> LookForServerWidgetItem(QTreeWidgetItem *Item);
		std::vector<OFileConnection*> LookForLocalWidgetItem(QTreeWidgetItem *Item);

		OFileConnection* LookForWidgetItems(QTreeWidgetItem *Local, QTreeWidgetItem *Server);

		bool DeleteConnection(QTreeWidgetItem *LocalItem, QTreeWidgetItem *ServerItem);

		QByteArray ToByteArray();
		bool FromByteArray(QByteArray);
};

#endif
