/***************************************************************************
 *   Copyright (C) 2007 by Stefan Lau   *
 *   stefan.lau@gmx.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef __WIN32__
	#define Win 1
#else
	#define Win 0
#endif

#ifndef __FTPWINDOWIMPL_H__
#define __FTPWINDOWIMPL_H__
 
#include "ui_ftpwindow.h"
#include "updatefilestatusimpl.h"
#include "def.h"
#include <QtGui>
#include <QFtp>
#include <QFile>
#include <QDir>
//
class FTPWindowImpl : public QWidget, public Ui::FTPWindow
{
Q_OBJECT
public:
	FTPWindowImpl(QString Dir, QString Profile, QString ProxyIP = 0, QString ProxyPort = 0);
	bool Upload(OProfile *ProfiletoUpload, std::vector<OFileConnection*> SelectedFiles);
	bool Download(OProfile *ProfiletoDownload, std::vector<OFileConnection*> SelectedFiles);

	void SetupCaptionsAndIcons();

	QString SizeToString(int Done, int Total);

private:
	QFtp FTP;

	OProfile *Profile;
	std::vector<OFileConnection*> FilesToProcess;
	int CurrentFile;
	
	bool Downloading;

	double Average;
	double Velocity;

	bool DownloadFile();
	bool UploadFile();
	bool Aborted;

	QTimer ProgressTimer;
	int Everything;

	int DoneTotalBefore;

	int DoneBefore;

	int TimerSinceLastCheck;
	int TimerTotal;

	QFile *LastFile;
private slots:

	void Progress(qint64 done, qint64 total);
	void ProgressTimerEvent();

	void ftp_commandFinished(int ID, bool Error);
	void ftp_done(bool error);

	void PB_Cancel_clicked();
};
 

#endif // __FTPWINDOWIMPL_H__
