/***************************************************************************
 *   Copyright (C) 2007 by Stefan Lau   *
 *   stefan.lau@gmx.net   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifdef __WIN32__
	#define Win 1
#else
	#define Win 0
#endif

#include "def.h"
#include "mainwindowimpl.h"

#include <stdio.h>

#include <QApplication>
#include <QTextStream>
#include <QTranslator>
#include <QLocale>
#include <QBuffer>
#include <QtCrypto>

void Read01(QTextStream *InputStream, MainWindowImpl *win) {
	
	QString Convert = InputStream->readLine();
	for (int i=0; i < Convert.toInt();i++) {
		OProfile *NewProfile = new OProfile();
		NewProfile->Name = InputStream->readLine();
			
		QString Convert = InputStream->readLine();
		
		for (int j=0; j < Convert.toInt();j++)
			NewProfile->Files.push_back(new OFileConnection);

		
		for (int j=0; j < Convert.toInt();j++) {
			QString temp = InputStream->readLine();
			if (temp[0] == QChar('/')) temp.remove(0,1);
			NewProfile->Files[j]->LocalFile = temp;
			}
			
		for (int k=0; k < Convert.toInt();k++) {
			QString temp = InputStream->readLine();			
			if (temp[0] == QChar('/')) temp.remove(0,1);
			NewProfile->Files[k]->ServerFile = temp;
		}
			
		NewProfile->Server = InputStream->readLine();
		NewProfile->Username = InputStream->readLine();
		NewProfile->Password = InputStream->readLine();
		if (Win) NewProfile->LocalBaseDir = "C:\\";

		win->Profiles.push_back(NewProfile);
	}
}

void Read02(QTextStream *InputStream, MainWindowImpl *win) {
	QString Convert = InputStream->readLine();
	for (int i=0; i < Convert.toInt();i++) {
		OProfile *NewProfile = new OProfile();

		NewProfile->Name = InputStream->readLine();
			
		QString Convert = InputStream->readLine();
			

		for (int j=0; j < Convert.toInt();j++)
			NewProfile->Files.push_back(new OFileConnection);

		for (int j=0; j < Convert.toInt();j++) {
			QString temp = InputStream->readLine();
			NewProfile->Files[j]->LocalFile = temp;
			}	
			
		for (int j=0; j < Convert.toInt();j++) {
			QString temp = InputStream->readLine();			
			NewProfile->Files[j]->ServerFile = temp;
			
		}

		NewProfile->Server = InputStream->readLine();
		NewProfile->Username = InputStream->readLine();
		NewProfile->Password = InputStream->readLine();
		NewProfile->LocalBaseDir = InputStream->readLine();
		NewProfile->ServerBaseDir = InputStream->readLine();

		win->Profiles.push_back(NewProfile);
	}
}

void Read05(QTextStream *InputStream, MainWindowImpl *win) {
	QString Convert = InputStream->readLine();
	for (int i=0; i < Convert.toInt();i++) {
		OProfile *NewProfile = new OProfile();

		NewProfile->Name = InputStream->readLine();
			
		QString Convert = InputStream->readLine();
			

		for (int j=0; j < Convert.toInt();j++)
			NewProfile->Files.push_back(new OFileConnection);

		for (int j=0; j < Convert.toInt();j++) {
			QString temp = InputStream->readLine();
			NewProfile->Files[j]->LocalFile = temp;
			}	
			
		for (int j=0; j < Convert.toInt();j++) {
			QString temp = InputStream->readLine();			
			NewProfile->Files[j]->ServerFile = temp;
			
		}

		NewProfile->Server = InputStream->readLine();
		NewProfile->Username = InputStream->readLine();
		NewProfile->Password = InputStream->readLine();
		NewProfile->LocalBaseDir = InputStream->readLine();
		NewProfile->ServerBaseDir = InputStream->readLine();
		if (InputStream->readLine() == "True") NewProfile->CheckForMDTM = 1; else NewProfile->CheckForMDTM = 0;
		if (InputStream->readLine() == "True") NewProfile->CheckForSize = 1; else NewProfile->CheckForSize = 0;

		win->Profiles.push_back(NewProfile);
	}
}

int main(int argc, char ** argv)
{	
	QApplication app( argc, argv );
	app.setQuitOnLastWindowClosed(0);
	
	QIcon oneclickftpicon;
	oneclickftpicon.addFile(":/icons/oneclickftp.png");
	
	//HauptFenster
	MainWindowImpl win;
	win.setWindowIcon(oneclickftpicon);
	
	//Übersetzung
	QTranslator Translator;
	
	int Lang = win.Settings->value("Language", 0).toInt();
	QString TransFile;
	if (Lang == 0) TransFile = "English.qm";
	if (Lang == 1) TransFile = "German.qm";
	if (!Translator.load(":/tr/"+TransFile+".qm")) Translator.load(":/tr/English.qm");
	win.CurrentTrans = &Translator;
	app.installTranslator(&Translator);
	
	//Einstellungen
	QCoreApplication::setOrganizationName("Stefan Lau");
    	QCoreApplication::setApplicationName("OneClickFTP");
		
	//Profile initialisieren
	QDir *ConfDir = new QDir(QDir::homePath()+"/.oneclickftp");
	if (ConfDir->exists()) {
		
	} else {
		ConfDir->mkdir(QDir::homePath()+"/.oneclickftp");
	}
	delete ConfDir;
	
	QFile *ConfFile = new QFile(QDir::homePath()+"/.oneclickftp/profiles");
	if (ConfFile->exists()) {
		ConfFile->open(QFile::ReadWrite);	
	
	
		QCA::Initializer Init;
		QCA::SecureArray EncryptedArray = ConfFile->readAll();
		ConfFile->close();
		
		QCA::SymmetricKey Key(QByteArray("Thisisthefuckingpassword"));
		QCA::InitializationVector InitVec(QByteArray("Thisisthefuckingpassword"));
		QCA::Cipher Cipher(QString("blowfish"), QCA::Cipher::CBC, QCA::Cipher::DefaultPadding, QCA::Decode, Key, InitVec);	
		QBuffer Buffer;
		Buffer.setData(Cipher.process(EncryptedArray).toByteArray());
		Buffer.open(QIODevice::ReadWrite);
	
		QTextStream *InputStream = new QTextStream(&Buffer);
		
		QString Version = InputStream->readLine();
		if (Version == "0.1") {
			Read01(InputStream, &win);
			QCA::Hash Hash("md5");
			win.Settings->setValue("EnterPasswordOnStartup", Hash.hash(QByteArray("Hell%No")).toByteArray());
		}
		if (Version == "0.2") {
			Read02(InputStream, &win);
			QCA::Hash Hash("md5");
			win.Settings->setValue("EnterPasswordOnStartup", Hash.hash(QByteArray("Hell%No")).toByteArray());
		}
		if (Version == "0.2.2") Read02(InputStream, &win);
		if (Version == "0.5.0") Read05(InputStream, &win);
		ConfFile->close();
		delete InputStream;
		} else {
		QCA::Initializer Init;
		QCA::Hash Hash("md5");
		win.Settings->setValue("EnterPasswordOnStartup", Hash.hash(QByteArray("Hell%No")).toByteArray());
	}
	delete ConfFile;	
	
	bool GotPassword = win.CheckForPassword(1);
	//bool GotPassword = 1;
	
	if (GotPassword) {
		win.SaveProfiles();
		win.SetupCaptionsAndIcons();
		win.SetupMenus();	
		win.ShowProfiles(0);
		win.restoreGeometry(win.Settings->value("Geometry").toByteArray());
		if (win.Settings->value("MinimizeOnStartup", 0).toBool()) win.hide(); else win.show();
		return app.exec();
	}
}
